alter table i18n_entity drop constraint i18n_entity_language_fk;

drop index language_lcode_idx;
drop index language_lname_idx;
alter table language drop constraint language_pk cascade drop index;

rename language to agc_language;

alter table AGC_LANGUAGE
  add constraint AGC_LANGUAGE_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

create unique index AGC_LANGUAGE_LCODE_IDX on AGC_LANGUAGE (LOWER(CODE))
  tablespace &INDEX_TABLESPACE compute statistics;

create unique index AGC_LANGUAGE_LNAME_IDX on AGC_LANGUAGE (LOWER(NAME))
  tablespace &INDEX_TABLESPACE compute statistics;

rename language_seq to agc_language_seq;
