CREATE OR REPLACE TRIGGER TRG_USER_EV_ERC_TO_PER_PROFILE
  BEFORE INSERT ON USER_EVENT_ERC
  FOR EACH ROW
declare
  counter              number(16);
begin
  --se non esiste l'entry su person_profile, usciamo dal trigger, la tabella person_profile non si allinea
  select count(1) into counter from person_profile t where t.ext_id = :new.event_out;
  if ( counter = 0 ) then
    return;
  end if;

  if ( :new.operation in ( 1, 2 ) ) then
    if ( :new.operation = 1 ) then
      --richiesta assegnazione permesso su target
      update person_profile set status = 1, verify_date = sysdate
      where ext_id = :new.event_out;
    elsif ( :new.operation = 2 ) then
      --richiesta rimozione permesso su target
      update person_profile set status = 11, verify_date = sysdate
      where ext_id = :new.event_out;
    end if;
  end if;

end TRG_USER_EV_ERC_TO_PER_PROFILE;
/
