alter table EXTERNALMAPPING add DEFAULT_VALUE VARCHAR2(256 CHAR);
alter table EXTERNALMAPPING add EDITABLE NUMBER(1);
alter table EXTERNALMAPPING add LOOKUP VARCHAR2(256 CHAR);
alter table EXTERNALMAPPING add LOOKUP_TYPE NUMBER(1);
alter table EXTERNALMAPPING add LOCALIZATION NUMBER(16);
alter table EXTERNALMAPPING add UI_RENDERING NUMBER(2);

comment on column EXTERNALMAPPING.REQUIRED
  is '0: NOT REQUIRED - 1: REQUIRED NOT NULL ON DB - 2: REQUIRED ON UI';
comment on column EXTERNALMAPPING.LOOKUP_TYPE
  is '0: INTERNAL LOOKUP - 1: POPUP WINDOW LOOKUP - 2: SELECTFIELD LOOKUP';

alter table EXTERNALMAPPING
  add constraint EXTMAPPING_LOCALIZATION_FK foreign key (LOCALIZATION)
  references localization (ID) on delete set null;
