declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'OU';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ACTION_TYPE';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ACTION_CAUSE';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ACTION_TYPE_LAST';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ACTION_CAUSE_LAST';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'GIVEN_NAME';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'SURNAME';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'GENDER';
  ext_col_size  numeric(16)  := '64';
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'BIRTH_PLACE';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'BIRTH_COUNTRY';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'CURRENTOU';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'NATION';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ZIPCODE';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'COUNTRY';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR1';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR2';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR3';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR4';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR5';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR6';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR7';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR8';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR9';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR11';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR12';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR13';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR14';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'ATTR15';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'CITY';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;

declare
  ra_name       varchar(256) := 'DB_TABLENAME';
  ra_value      varchar(256) := 'USER_ERC';
  ext_name      varchar(256) := 'AD_OU';
  ext_col_size  numeric(16)  := 512;
  counter       numeric(16);
begin
  select count(1) into counter from externalmapping where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  if ( counter > 0 ) then
    update externalmapping set column_size = ext_col_size where name = ext_name and repository in ( select distinct t.repository from repository_attribute t where t.name = ra_name and t.value = ra_value );
  end if;
end;
/
commit;
