declare
  cur_pwd      sys_refcursor;
  pwd_id       numeric(16);
  
  counter      numeric(16);
begin
  open cur_pwd for select id from pwdcfg;
  loop
    fetch cur_pwd into pwd_id;
    exit when cur_pwd%NOTFOUND;
    
    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'ACCOUNT_CREATION_USERID_POLICY';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'ACCOUNT_CREATION_USERID_POLICY', 'Ideas' );
    end if;
    
    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'ACCOUNT_CREATION_FLOW_ENABLED';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'ACCOUNT_CREATION_FLOW_ENABLED', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'ACCOUNT_CREATION_FLOWID';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'ACCOUNT_CREATION_FLOWID', '' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWD_DEFAULT';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWD_DEFAULT', '' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWD_SPECIAL_CHAR_ALLOWED';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWD_SPECIAL_CHAR_ALLOWED', '11111111111111111111111111111111' );
    end if;

  end loop;
  close cur_pwd;
end;
/
commit;
