alter table arm_i18n_message drop constraint arm_i18n_message_loc_code_fk;
alter table mn_role_mapping drop constraint mn_role_map_localiz_code_fk;
alter table mn_tree drop constraint mn_tree_localiz_code_fk;

alter table localization_code drop constraint localization_code_pk cascade drop index;

rename localization_code to arm_localization_code;

alter table ARM_LOCALIZATION_CODE
  add constraint ARM_LOCALIZATION_CODE_PK primary key (ID)
  using index 
  tablespace IGA_CORE_DATA compute statistics;

ALTER TABLE ARM_I18N_MESSAGE ADD (
  CONSTRAINT ARM_I18N_MESSAGE_LOC_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE CASCADE);

ALTER TABLE MN_ROLE_MAPPING ADD (
  CONSTRAINT MN_ROLE_MAP_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL);

ALTER TABLE MN_TREE ADD (
  CONSTRAINT MN_TREE_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL);

rename localization_code_seq to arm_localization_code_seq;
