declare
  counter         numeric(16);
begin
  select count(1) into counter from cfg_process p, cfg_processactivity pa, cfg_activity a
  where p.functionality_context = 'ENTITY_CHANGE'
  and p.id = pa.process and pa.activity = a.id
  and a.functionality like '%ENTITLEMENT%';
  
  if ( counter > 0 ) then
    update cfg_process set functionality_context = 'ENTITLEMENT_MANAGEMENT' where id in (
    select distinct p.id from cfg_process p, cfg_processactivity pa, cfg_activity a
    where p.functionality_context = 'ENTITY_CHANGE'
    and p.id = pa.process and pa.activity = a.id
    and a.functionality like '%ENTITLEMENT%');
  end if;
end;
/
commit;

declare
  counter         numeric(16);
begin
  select count(1) into counter from cfg_process p, cfg_processactivity pa, cfg_activity a
  where p.functionality_context = 'ENTITY_CHANGE'
  and p.id = pa.process and pa.activity = a.id
  and a.functionality like '%USER%';
  
  if ( counter > 0 ) then
    update cfg_process set functionality_context = 'USER_MANAGEMENT' where id in (
    select distinct p.id from cfg_process p, cfg_processactivity pa, cfg_activity a
    where p.functionality_context = 'ENTITY_CHANGE'
    and p.id = pa.process and pa.activity = a.id
    and a.functionality like '%USER%');
  end if;
end;
/
commit;
