rename ems_localization_tmp to ems_localization;

ALTER TABLE EMS_LOCALIZATION ADD (
  CONSTRAINT EMS_LOCALIZATION_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE IGA_CORE_DATA COMPUTE STATISTICS);

ALTER TABLE EMS_I18N_MESSAGE ADD (
  CONSTRAINT EMS_I18N_LOCALIZATION_FK
 FOREIGN KEY (LOCALIZATION)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE);

ALTER TABLE EMS_TEMPLATE ADD (
  CONSTRAINT EMS_TEMPLATE_BODY_FK
 FOREIGN KEY (BODY)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE);

ALTER TABLE EMS_TEMPLATE ADD (
  CONSTRAINT EMS_TEMPLATE_SUBJECT_FK
 FOREIGN KEY (SUBJECT)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE);

create unique index EMS_LOCALIZATION_LNAME_IDX on EMS_LOCALIZATION (LOWER(CODE))
  TABLESPACE IGA_CORE_INDX COMPUTE STATISTICS;
  
rename ems_localization_tmp_seq to ems_localization_seq;
