declare
  counter          numeric(16);
  
  --report type
  rt_id            numeric(16);
  rt_name          varchar(256) := '';
  rt_desc          varchar(512) := '';

  --report parent
  rp_id            numeric(16);
  rp_name          varchar(256) := '';

  r_id             numeric(16);
  r_name_old       varchar(256) := 'Technical transformation status';
  r_name           varchar(256) := 'Technical transformation status';
  r_desc           varchar(512) := '';
  r_code           varchar(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 0;

  r_loc_id         numeric(16);
  r_loc_code       varchar(256);

  rq_id            numeric(16);
  rq_name_old      varchar(256) := 'Technical transformation status';
  rq_name          varchar(256) := 'Technical transformation status';
  rq_desc          varchar(512) := '';
  rqd              clob;
  
  --rv_name1         varchar(256) := '';
  --repv_vis_type1   numeric(2) := 2;

  rv_id            numeric(16);
  rv_name          varchar(256);
  rv_ent_id        numeric(16);
  repv_vis_type    numeric(2);
  rq_vis_pos       numeric(16);

  rqf_type_def     varchar(256) := 'java.lang.String';
  rqf_width_def    numeric(16) := 300;

  rqf_id           numeric(16);
  rqf_name_old     varchar(256);
  rqf_name         varchar(256);
  rqf_type         varchar(256);
  rqf_width        numeric(16);
  rqf_ord_by       numeric(1);
  rqf_ord_by_clau  varchar(256);
  rqf_ord_pos      numeric(16);
  loc_id           numeric(16);
  loc_code_old     varchar(256);
  loc_code         varchar(256);
  i18n_msg         varchar(256);
  repf_pos_id      numeric(16);
  repf_pos_id_old  numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar(256) := null;
  rqf_name1        varchar(256) := 'PERMISSION_STATUS';
  rqf_type1        varchar(256) := rqf_type_def;
  rqf_width1       varchar(256) := rqf_width_def;
  rqf_ord_by1      numeric(1)   := 0;
  rqf_ord_by_clau1 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar(256) := null;
  loc_code1        varchar(256) := 'permission.status';
  i18n_msg1        varchar(256) := 'Permission Status';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     numeric(16)  := 5;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name2_old    varchar(256) := null;
  rqf_name2        varchar(256) := 'PERMISSION_NAME';
  rqf_type2        varchar(256) := rqf_type_def;
  rqf_width2       varchar(256) := rqf_width_def;
  rqf_ord_by2      numeric(1)   := 0;
  rqf_ord_by_clau2 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code2_old    varchar(256) := null;
  loc_code2        varchar(256) := 'permission.name';
  i18n_msg2        varchar(256) := 'Permission';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id2     numeric(16)  := 1;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name3_old    varchar(256) := null;
  rqf_name3        varchar(256) := 'PERMISSION_DESC';
  rqf_type3        varchar(256) := rqf_type_def;
  rqf_width3       varchar(256) := rqf_width_def;
  rqf_ord_by3      numeric(1)   := 0;
  rqf_ord_by_clau3 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code3_old    varchar(256) := null;
  loc_code3        varchar(256) := 'permission.desc';
  i18n_msg3        varchar(256) := 'Permission Descr.';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id3     numeric(16)  := 4;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name4_old    varchar(256) := null;
  rqf_name4        varchar(256) := 'APPLICATION_NAME';
  rqf_type4        varchar(256) := rqf_type_def;
  rqf_width4       varchar(256) := rqf_width_def;
  rqf_ord_by4      numeric(1)   := 0;
  rqf_ord_by_clau4 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code4_old    varchar(256) := null;
  loc_code4        varchar(256) := 'application.name';
  i18n_msg4        varchar(256) := 'Application';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id4     numeric(16)  := 0;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name5_old    varchar(256) := null;
  rqf_name5        varchar(256) := 'PROFILE_TYPE';
  rqf_type5        varchar(256) := rqf_type_def;
  rqf_width5       varchar(256) := rqf_width_def;
  rqf_ord_by5      numeric(1)   := 0;
  rqf_ord_by_clau5 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code5_old    varchar(256) := null;
  loc_code5        varchar(256) := 'profile.type';
  i18n_msg5        varchar(256) := 'Permission Type';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id5     numeric(16)  := 2;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name6_old    varchar(256) := null;
  rqf_name6        varchar(256) := 'ACTIVITY_NAME';
  rqf_type6        varchar(256) := rqf_type_def;
  rqf_width6       varchar(256) := rqf_width_def;
  rqf_ord_by6      numeric(1)   := 0;
  rqf_ord_by_clau6 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code6_old    varchar(256) := null;
  loc_code6        varchar(256) := 'activity.name';
  i18n_msg6        varchar(256) := 'Activity Name';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id6     numeric(16)  := 6;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name7_old    varchar(256) := null;
  rqf_name7        varchar(256) := 'ACTIVITY_PATH';
  rqf_type7        varchar(256) := rqf_type_def;
  rqf_width7       varchar(256) := rqf_width_def;
  rqf_ord_by7      numeric(1)   := 0;
  rqf_ord_by_clau7 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code7_old    varchar(256) := null;
  loc_code7        varchar(256) := 'activity.path';
  i18n_msg7        varchar(256) := 'Activity Path';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id7     numeric(16)  := 7;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name8_old    varchar(256) := null;
  rqf_name8        varchar(256) := 'ACTIVITY_CODE';
  rqf_type8        varchar(256) := rqf_type_def;
  rqf_width8       varchar(256) := rqf_width_def;
  rqf_ord_by8      numeric(1)   := 0;
  rqf_ord_by_clau8 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code8_old    varchar(256) := null;
  loc_code8        varchar(256) := 'activity.code';
  i18n_msg8        varchar(256) := 'Activity Code';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id8     numeric(16)  := 8;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name9_old    varchar(256) := null;
  rqf_name9        varchar(256) := 'PERMISSION_CODE';
  rqf_type9        varchar(256) := rqf_type_def;
  rqf_width9       varchar(256) := rqf_width_def;
  rqf_ord_by9      numeric(1)   := 0;
  rqf_ord_by_clau9 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code9_old    varchar(256) := null;
  loc_code9        varchar(256) := 'permission.code';
  i18n_msg9        varchar(256) := 'Permission Code';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id9     numeric(16)  := 3;

  repfr_id         numeric(16);
  repfr_name_old   varchar(256);
  repfr_name       varchar(256);
  repfr_value      varchar(256);
  repfr_l_id       numeric(16);
  repfr_l_code_old varchar(256);
  repfr_l_code     varchar(256);
  repfr_i18n_msg   varchar(256);
  repfr_vis        numeric(16);
  repfr_mand       numeric(16);
  repfr_type       numeric(16);
  repfr_cust_id    numeric(16);
  repfr_cust_name  varchar(256);
  repfr_pos_id     numeric(16);
  repfr_pos_id_old numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name1_old  varchar(256);
  repfr_name1      varchar(256) := 'permission_name';
  repfr_value1     varchar(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code1_old varchar(256) := null;
  repfr_l_code1    varchar(256) := 'permission.name';
  repfr_i18n_msg1  varchar(256) := 'Permission';
  repfr_vis1       numeric(16)  := 1;
  repfr_mand1      numeric(16)  := 0;
  repfr_type1      numeric(16)  := 0;
  repfr_cust_name1 varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id1    numeric(16);
  repfr_pos_id1_old numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name2_old  varchar(256);
  repfr_name2      varchar(256) := 'permission_status';
  repfr_value2     varchar(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code2_old varchar(256) := null;
  repfr_l_code2    varchar(256) := 'permission.status';
  repfr_i18n_msg2  varchar(256) := 'Permission Status';
  repfr_vis2       numeric(16)  := 1;
  repfr_mand2      numeric(16)  := 0;
  repfr_type2      numeric(16)  := 3;
  repfr_cust_name2 varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id2    numeric(16);
  repfr_pos_id2_old numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name3_old  varchar(256);
  repfr_name3      varchar(256) := 'application_name';
  repfr_value3     varchar(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code3_old varchar(256) := null;
  repfr_l_code3    varchar(256) := 'application.name';
  repfr_i18n_msg3  varchar(256) := 'Application';
  repfr_vis3       numeric(16)  := 1;
  repfr_mand3      numeric(16)  := 0;
  repfr_type3      numeric(16)  := 0;
  repfr_cust_name3 varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id3    numeric(16);
  repfr_pos_id3_old numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name4_old  varchar(256);
  repfr_name4      varchar(256) := 'activity_code';
  repfr_value4     varchar(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code4_old varchar(256) := null;
  repfr_l_code4    varchar(256) := 'activity.code';
  repfr_i18n_msg4  varchar(256) := 'Activity Code';
  repfr_vis4       numeric(16)  := 1;
  repfr_mand4      numeric(16)  := 0;
  repfr_type4      numeric(16)  := 0;
  repfr_cust_name4 varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id4    numeric(16);
  repfr_pos_id4_old numeric(16);

  cur_lan          sys_refcursor;
  lan_id           numeric(16);
  
  cur_rep          sys_refcursor;
  rep_id           numeric(16);

begin
  rqd := 'select
'||'           --t.permission_id,
'||'           case
'||'             when t.permission_status = 0 then ''TBD''
'||'             when t.permission_status = 1 then ''Linked''
'||'             when t.permission_status = 0 then ''Ignored''
'||'             when t.permission_status = 3 then ''Missing Activities''
'||'             else ''-''
'||'           end as permission_status,
'||'           t.permission as permission_name,
'||'           t.permission_description as permission_desc,
'||'           t.application_name as application_name,
'||'           t.permission_type_name as profile_type,
'||'           tp.activity as activity_name,
'||'           tp.activity_path as activity_path,
'||'           tp.activity_code as activity_code,
'||'           --tp.env_id,
'||'           t.permission_code
'||'      from (select e.id          as permission_id,
'||'                   e.state       as permission_status,
'||'                   e.name        as permission,
'||'                   e.code        as permission_code,
'||'                   e.description as permission_description,
'||'                   a.name        as application_name,
'||'                   pt.name       as permission_type_name
'||'              from  #pmschema#.entitlement  e,
'||'                    #pmschema#.application  a,
'||'                    #pmschema#.profile_type pt
'||'             where e.ext_type = a.sod_ext_level
'||'               and e.application = a.id
'||'               and e.profile_type = pt.id
'||'               and e.administrative = 0
'||'               and pt.application = a.id
'||'               and lower ( e.name ) like lower ( ''#permission_name#'' )
'||'               and e.state in (0, 1, 2, 3)) t
'||'      left outer join (select distinct tp.profile,
'||'                                       tp.task,
'||'                                       t.name as activity,
'||'                                       t.path as activity_path,
'||'                                       t.code as activity_code,
'||'                                       env.id as env_id
'||'                         from (select pgr.profile, t.task, t.environment
'||'                                 from  #pmschema#.profile_group pgr,
'||'                                      (select tp.task, pg.root, tp.environment
'||'                                         from  #pmschema#.task_profile  tp,
'||'                                               #pmschema#.entitlement   e,
'||'                                               #pmschema#.profile_group pg
'||'                                        where e.int_type = 0
'||'                                          and tp.profile = e.id
'||'                                          and e.administrative = 0
'||'                                          and e.id = pg.profile) t
'||'                                where pgr.root = t.root
'||'                                  and pgr.type = 3
'||'                               union
'||'                               select tp.profile, tp.task, tp.environment
'||'                                 from  #pmschema#.task_profile tp,
'||'                                       #pmschema#.entitlement  e,
'||'                                       #pmschema#.application a
'||'                                where e.application = a.id
'||'                                  and e.ext_type = a.sod_ext_level
'||'                                  and e.administrative = 0
'||'                                  and tp.profile = e.id) tp,
'||'                               #pmschema#.environment env,
'||'                               #pmschema#.task t
'||'                        where env.working = 1
'||'                          and env.id = tp.environment
'||'                          and tp.environment = t.environment
'||'                          and tp.task = t.id) tp on tp.profile = t.permission_id
'||'     where 1 = 1
'||'       and t.permission_status = #permission_status#
'||'       and lower ( t.application_name ) like lower ( ''#application_name#'' )
'||'       and ( lower ( tp.activity_code ) like lower ( ''#activity_code#'' ) or tp.activity_code is null )
'||'';

  --sezione query
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_name <> rq_name_old ) then
    update r_query set name = rq_name where name = rq_name_old;
  end if;
  
  --sezione report
  select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      /*select dbms_random.random into r_loc_code from dual;*/
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      select int((rand()-0.5) * 32768) into r_loc_code from dual;
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;

    open cur_lan for select t.id from language t where t.language_status > 0;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      
      select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
      if ( counter = 0 ) then
        insert into i18n_message ( id, localization, language, message )
        values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_name );
      else
        update i18n_message set message = r_name where language = lan_id and localization = r_loc_id;
      end if;

    end loop;
    close cur_lan;

    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'CHART', '0' );
    end if;    
  else
    select t.id into r_id from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  end if;

  --modifica il nome del report
  if ( r_name <> r_name_old ) then
    update report set name = r_name where name = r_name_old and dashboard = r_dashboard;
  end if;
  
  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

  --QUERY FIELD 2: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name2_old;
  rqf_name        := rqf_name2;
  rqf_type        := rqf_type2;
  rqf_width       := rqf_width2;
  rqf_ord_by      := rqf_ord_by2;
  rqf_ord_by_clau := rqf_ord_by_clau2;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code2_old;
  loc_code        := loc_code2;
  i18n_msg        := i18n_msg2;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id2;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 2: END

  --QUERY FIELD 3: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name3_old;
  rqf_name        := rqf_name3;
  rqf_type        := rqf_type3;
  rqf_width       := rqf_width3;
  rqf_ord_by      := rqf_ord_by3;
  rqf_ord_by_clau := rqf_ord_by_clau3;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code3_old;
  loc_code        := loc_code3;
  i18n_msg        := i18n_msg3;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id3;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 3: END

  --QUERY FIELD 4: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name4_old;
  rqf_name        := rqf_name4;
  rqf_type        := rqf_type4;
  rqf_width       := rqf_width4;
  rqf_ord_by      := rqf_ord_by4;
  rqf_ord_by_clau := rqf_ord_by_clau4;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code4_old;
  loc_code        := loc_code4;
  i18n_msg        := i18n_msg4;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id4;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 4: END

  --QUERY FIELD 5: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name5_old;
  rqf_name        := rqf_name5;
  rqf_type        := rqf_type5;
  rqf_width       := rqf_width5;
  rqf_ord_by      := rqf_ord_by5;
  rqf_ord_by_clau := rqf_ord_by_clau5;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code5_old;
  loc_code        := loc_code5;
  i18n_msg        := i18n_msg5;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id5;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 5: END

  --QUERY FIELD 6: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name6_old;
  rqf_name        := rqf_name6;
  rqf_type        := rqf_type6;
  rqf_width       := rqf_width6;
  rqf_ord_by      := rqf_ord_by6;
  rqf_ord_by_clau := rqf_ord_by_clau6;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code6_old;
  loc_code        := loc_code6;
  i18n_msg        := i18n_msg6;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id6;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 6: END

  --QUERY FIELD 7: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name7_old;
  rqf_name        := rqf_name7;
  rqf_type        := rqf_type7;
  rqf_width       := rqf_width7;
  rqf_ord_by      := rqf_ord_by7;
  rqf_ord_by_clau := rqf_ord_by_clau7;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code7_old;
  loc_code        := loc_code7;
  i18n_msg        := i18n_msg7;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id7;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 7: END

  --QUERY FIELD 8: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name8_old;
  rqf_name        := rqf_name8;
  rqf_type        := rqf_type8;
  rqf_width       := rqf_width8;
  rqf_ord_by      := rqf_ord_by8;
  rqf_ord_by_clau := rqf_ord_by_clau8;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code8_old;
  loc_code        := loc_code8;
  i18n_msg        := i18n_msg8;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id8;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 8: END

  --QUERY FIELD 9: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name9_old;
  rqf_name        := rqf_name9;
  rqf_type        := rqf_type9;
  rqf_width       := rqf_width9;
  rqf_ord_by      := rqf_ord_by9;
  rqf_ord_by_clau := rqf_ord_by_clau9;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code9_old;
  loc_code        := loc_code9;
  i18n_msg        := i18n_msg9;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id9;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 9: END

  --REPORT FILTER 1: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name1_old;
  repfr_name         := repfr_name1;
  repfr_value        := repfr_value1;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code1_old;
  repfr_l_code       := repfr_l_code1;
  repfr_i18n_msg     := repfr_i18n_msg1;
  repfr_vis          := repfr_vis1;
  repfr_mand         := repfr_mand1;
  repfr_type         := repfr_type1;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name1;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id1;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 1 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 1 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(1) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 1 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 1;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 1 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -1 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 1 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -1;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 1: END

  --REPORT FILTER 2: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name2_old;
  repfr_name         := repfr_name2;
  repfr_value        := repfr_value2;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code2_old;
  repfr_l_code       := repfr_l_code2;
  repfr_i18n_msg     := repfr_i18n_msg2;
  repfr_vis          := repfr_vis2;
  repfr_mand         := repfr_mand2;
  repfr_type         := repfr_type2;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name2;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id2;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(2) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(2) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 2 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(2) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(2) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 2 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(2) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 2 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 2;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 2 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 2 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -2 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 2 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 2 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -2;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 2: END

  --REPORT FILTER 3: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name3_old;
  repfr_name         := repfr_name3;
  repfr_value        := repfr_value3;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code3_old;
  repfr_l_code       := repfr_l_code3;
  repfr_i18n_msg     := repfr_i18n_msg3;
  repfr_vis          := repfr_vis3;
  repfr_mand         := repfr_mand3;
  repfr_type         := repfr_type3;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name3;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id3;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(3) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(3) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 3 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(3) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(3) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 3 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(3) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 3 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 3;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 3 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 3 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -3 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 3 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 3 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -3;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 3: END

  --REPORT FILTER 4: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name4_old;
  repfr_name         := repfr_name4;
  repfr_value        := repfr_value4;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code4_old;
  repfr_l_code       := repfr_l_code4;
  repfr_i18n_msg     := repfr_i18n_msg4;
  repfr_vis          := repfr_vis4;
  repfr_mand         := repfr_mand4;
  repfr_type         := repfr_type4;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name4;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id4;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(4) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(4) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 4 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(4) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(4) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 4 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(4) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 4 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 4;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 4 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 4 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -4 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 4 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 4 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -4;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 4: END

end;
/

commit;
