declare
  counter          numeric(16);
  
  --report type
  rt_id            numeric(16);
  rt_name          varchar(256) := '';
  rt_desc          varchar(512) := '';

  --report parent
  rp_id            numeric(16);
  rp_name          varchar(256) := '';

  r_id             numeric(16);
  r_name_old       varchar(256) := 'Accounts expiring in next x days AM';
  r_name           varchar(256) := 'Accounts expiring in next x days with application scope';
  r_desc           varchar(512) := '';
  r_code           varchar(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;

  r_loc_id         numeric(16);
  r_loc_code       varchar(256);

  rq_id            numeric(16);
  rq_name_old      varchar(256) := 'Accounts expiring in next x days AM DB';
  rq_name          varchar(256) := 'Accounts expiring in next x days AM DB';
  rq_desc          varchar(512) := '';
  rqd              clob;
  
  rv_name1         varchar(256) := 'AG-Core Application';
  repv_vis_type1   numeric(2) := 3;

  rv_id            numeric(16);
  rv_name          varchar(256);
  rv_ent_id        numeric(16);
  repv_vis_type    numeric(2);
  rq_vis_pos       numeric(16);

  rqf_type_def     varchar(256) := 'java.lang.String';
  rqf_width_def    numeric(16) := 300;

  rqf_id           numeric(16);
  rqf_name_old     varchar(256);
  rqf_name         varchar(256);
  rqf_type         varchar(256);
  rqf_width        numeric(16);
  rqf_ord_by       numeric(1);
  rqf_ord_by_clau  varchar(256);
  rqf_ord_pos      numeric(16);
  loc_id           numeric(16);
  loc_code_old     varchar(256);
  loc_code         varchar(256);
  i18n_msg         varchar(256);
  repf_pos_id      numeric(16);
  repf_pos_id_old  numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar(256) := null;
  rqf_name1        varchar(256) := 'USER_CODE';
  rqf_type1        varchar(256) := rqf_type_def;
  rqf_width1       varchar(256) := rqf_width_def;
  rqf_ord_by1      numeric(1)   := 1;
  rqf_ord_by_clau1 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar(256) := null;
  loc_code1        varchar(256) := 'user.code';
  i18n_msg1        varchar(256) := 'UserID';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     numeric(16)  := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name2_old    varchar(256) := null;
  rqf_name2        varchar(256) := 'ACCOUNT_CODE';
  rqf_type2        varchar(256) := rqf_type_def;
  rqf_width2       varchar(256) := rqf_width_def;
  rqf_ord_by2      numeric(1)   := 1;
  rqf_ord_by_clau2 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code2_old    varchar(256) := null;
  loc_code2        varchar(256) := 'account.code';
  i18n_msg2        varchar(256) := 'Account Code';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id2     numeric(16)  := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name3_old    varchar(256) := null;
  rqf_name3        varchar(256) := 'PWDCONFIG_NAME';
  rqf_type3        varchar(256) := rqf_type_def;
  rqf_width3       varchar(256) := rqf_width_def;
  rqf_ord_by3      numeric(1)   := 1;
  rqf_ord_by_clau3 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code3_old    varchar(256) := null;
  loc_code3        varchar(256) := 'pwdconfig.name';
  i18n_msg3        varchar(256) := 'Account Configuration';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id3     numeric(16)  := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name4_old    varchar(256) := null;
  rqf_name4        varchar(256) := 'ACCOUNT_EXPIRY_DATE';
  rqf_type4        varchar(256) := 'java.util.Date';
  rqf_width4       varchar(256) := rqf_width_def;
  rqf_ord_by4      numeric(1)   := 0;
  rqf_ord_by_clau4 varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code4_old    varchar(256) := null;
  loc_code4        varchar(256) := 'account.expiry.date';
  i18n_msg4        varchar(256) := 'Account Expire Date';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id4     numeric(16)  := null;

  repfr_id         numeric(16);
  repfr_name_old   varchar(256);
  repfr_name       varchar(256);
  repfr_value      varchar(256);
  repfr_l_id       numeric(16);
  repfr_l_code_old varchar(256);
  repfr_l_code     varchar(256);
  repfr_i18n_msg   varchar(256);
  repfr_vis        numeric(16);
  repfr_mand       numeric(16);
  repfr_type       numeric(16);
  repfr_cust_id    numeric(16);
  repfr_cust_name  varchar(256);
  repfr_pos_id     numeric(16);
  repfr_pos_id_old numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name1_old  varchar(256);
  repfr_name1      varchar(256) := 'day_number';
  repfr_value1     varchar(256) := '30';
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code1_old varchar(256) := null;
  repfr_l_code1    varchar(256) := 'day.number';
  repfr_i18n_msg1  varchar(256) := '# days from today';
  repfr_vis1       numeric(16)  := 0;
  repfr_mand1      numeric(16)  := 0;
  repfr_type1      numeric(16)  := 3;
  repfr_cust_name1 varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id1    numeric(16);
  repfr_pos_id1_old numeric(16);
  cur_lan          sys_refcursor;
  lan_id           numeric(16);
  
  cur_rep          sys_refcursor;
  rep_id           numeric(16);

begin
  rqd := 'select distinct
'||'  --t.name as target_name,
'||'  --a.name as application_name,
'||'  p.code as user_code,
'||'  pwdm.code as account_code,
'||'  --case
'||'  --  when pwdm.name is null then p.name
'||'  --end as user_name,
'||'  --case
'||'  --  when pwdm.surname is null then p.surname
'||'  --end as user_surname,
'||'  --case
'||'  --  when pwdm.email is null then p.email
'||'  --end as user_email,
'||'  pwdc.name as pwdconfig_name,
'||'  pwdm.expire as account_expiry_date
'||'from
'||'  #schema_tmp#.tmp_rep_application tmpa,
'||'  #pmschema#.application a,
'||'  #pmschema#.target t,
'||'  #pmschema#.pwdcfg pwdc,
'||'  #pmschema#.pwdmanagement pwdm,
'||'  #pmschema#.person p
'||'where tmpa.id = a.id
'||'  and a.target = t.id
'||'  and t.pwdcfg = pwdc.id
'||'  and pwdc.id = pwdm.pwdcfg
'||'  and pwdm.person = p.id
'||'  and pwdm.expire is not null
'||'  and pwdm.expire >= current_date
'||'  and pwdm.expire <=
'||'       to_date(extract(year from current_date + #day_number#) || ''/'' ||
'||'               extract(month from current_date + #day_number#) || ''/'' ||
'||'               extract(day from current_date + #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'')
'||'';

  --sezione query
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_name <> rq_name_old ) then
    update r_query set name = rq_name where name = rq_name_old;
  end if;
  
  --sezione report
  select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      /*select dbms_random.random into r_loc_code from dual;*/
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      select int((rand()-0.5) * 32768) into r_loc_code from dual;
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;

    open cur_lan for select t.id from language t where t.language_status > 0;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      
      select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
      if ( counter = 0 ) then
        insert into i18n_message ( id, localization, language, message )
        values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_name );
      else
        update i18n_message set message = r_name where language = lan_id and localization = r_loc_id;
      end if;

    end loop;
    close cur_lan;

    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'CHART', '0' );
    end if;    
  else
    select t.id into r_id from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  end if;

  --modifica il nome del report
  if ( r_name <> r_name_old ) then
    update report set name = r_name where name = r_name_old and dashboard = r_dashboard;
  end if;
  
  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

  --QUERY FIELD 2: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name2_old;
  rqf_name        := rqf_name2;
  rqf_type        := rqf_type2;
  rqf_width       := rqf_width2;
  rqf_ord_by      := rqf_ord_by2;
  rqf_ord_by_clau := rqf_ord_by_clau2;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code2_old;
  loc_code        := loc_code2;
  i18n_msg        := i18n_msg2;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id2;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 2: END

  --QUERY FIELD 3: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name3_old;
  rqf_name        := rqf_name3;
  rqf_type        := rqf_type3;
  rqf_width       := rqf_width3;
  rqf_ord_by      := rqf_ord_by3;
  rqf_ord_by_clau := rqf_ord_by_clau3;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code3_old;
  loc_code        := loc_code3;
  i18n_msg        := i18n_msg3;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id3;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 3: END

  --QUERY FIELD 4: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name4_old;
  rqf_name        := rqf_name4;
  rqf_type        := rqf_type4;
  rqf_width       := rqf_width4;
  rqf_ord_by      := rqf_ord_by4;
  rqf_ord_by_clau := rqf_ord_by_clau4;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code4_old;
  loc_code        := loc_code4;
  i18n_msg        := i18n_msg4;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id4;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 4: END

  --REPORT FILTER 1: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name1_old;
  repfr_name         := repfr_name1;
  repfr_value        := repfr_value1;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code1_old;
  repfr_l_code       := repfr_l_code1;
  repfr_i18n_msg     := repfr_i18n_msg1;
  repfr_vis          := repfr_vis1;
  repfr_mand         := repfr_mand1;
  repfr_type         := repfr_type1;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name1;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id1;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 1 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 1 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(1) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 1 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 1;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 1 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -1 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 1 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -1;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 1: END

  --QUERY VISIBILITY AND REPORT VISIBILITY 1: BEGIN
  rv_name := rv_name1;
  repv_vis_type := repv_vis_type1;
  select count (1) into counter from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
  if ( counter = 1 ) then
    select rv.id, rv.entity into rv_id, rv_ent_id from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
    
    --QUERY VISIBILITY
    select count(1) into counter from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;

    if ( counter = 0 ) then
      select max ( rqv.position ) + 1 into rq_vis_pos from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;
      if ( rq_vis_pos is null ) then
        rq_vis_pos := 0;
      end if;
      insert into r_query_visibility ( id, r_query, r_visibility, position )
      values ( r_query_visibility_seq.nextval, rq_id, rv_id, rq_vis_pos );
    end if;

    --REPORT VISIBILITY
    select count(1) into counter from report_visibility rv where rv.report = r_id and rv.r_visibility = rv_id;

    if ( counter = 0 ) then
      insert into report_visibility ( id, report, entity, vis_type, r_visibility )
      values ( report_visibility_seq.nextval, r_id, rv_ent_id, repv_vis_type, rv_id );
    end if;
  end if;
  --QUERY VISIBILITY AND REPORT VISIBILITY 1: END

end;
/

commit;
