update report_attribute set value = '3' where id in (
  select t.id from report_attribute t where t.report in (
    select t.id from report t where t.name in (
    'Days until the next password expiration',
    'Partial requests',
    'Rejected requests',
    'Illegal user without mitigation',
    'Locked accounts',
    'Delegation assignments'
    ) and t.dashboard = 1
  ) and t.name = 'CHART'
);

commit;
