declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Rejected requests DB';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select
'||'  count(1) as request_rejected
'||'from
'||'  #pmschema#.person                             p,
'||'  #swimschema#.request                            req
'||'where p.s_user = req.beneficiary
'||'  and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'  and req.req_status in ( 5 )
'||'  and req.parent is not null
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
