declare
  r_name_old       varchar(256) := 'Accounts expiring in next x days UM';
  r_name           varchar(256) := 'Accounts expiring in next x days with OU scope';
  r_desc           varchar(512) := '';
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;
  
  counter          numeric(16);
begin
  select count(1) into counter from report t where name = r_name_old and t.dashboard = r_dashboard;
  if ( counter = 1 ) then
    update report set name = r_name, description = r_desc where name = r_name_old and dashboard = r_dashboard;
  end if;
end;
/
commit;

declare
  r_name_old       varchar(256) := 'Accounts expiring in next x days AM';
  r_name           varchar(256) := 'Accounts expiring in next x days with application scope';
  r_desc           varchar(512) := '';
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;
  
  counter          numeric(16);
begin
  select count(1) into counter from report t where name = r_name_old and t.dashboard = r_dashboard;
  if ( counter = 1 ) then
    update report set name = r_name, description = r_desc where name = r_name_old and dashboard = r_dashboard;
  end if;
end;
/
commit;
