set define off
declare
  counter          numeric(16);
  r_id             numeric(16);
  r_name           varchar(256) := 'Business activity mapping status';
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;

  ra_id            numeric(16);
  ra_name          varchar(256);
  ra_value         varchar(256);

  ra_name_01       varchar(256) := 'DRILL_FILTER';
  ra_value_01      varchar(256) := 'status,$application';
begin
  select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  if ( counter = 1 ) then
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  else
    return;
  end if;
  
  --REPORT ATTRIBUTE 01
  ra_name  := ra_name_01;
  ra_value := ra_value_01;
  select count(1) into counter from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  if ( counter > 1 ) then
    delete from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  end if;

  select count(1) into counter from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  if ( counter = 0 ) then
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, ra_name, ra_value );
  else
    select t.id into ra_id from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
    update report_attribute set value = ra_value where id = ra_id;
  end if;

end;
/
commit;
set define on
