declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Recent requests DB';

  counter          numeric(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    select count(1) into counter from r_query_field t where t.r_query = rq_id;
    if ( counter > 0 ) then
      delete from r_query_field where r_query = rq_id;
    end if;
  end if;
end;
/
commit;
