declare
  sk_id       number(16);
  sk_name     varchar2(256) := 'Singleton';
  skp_id      number(16);
  skp_name    varchar2(256);
  skp_value   varchar2(256);

  counter     number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 1 ) then
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  else
    return;
  end if;
  
  skp_name := 'org.quartz.threadPool.class';
  skp_value := 'com.ibm.quartz.TaskExecutorThreadPool';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 0 ) then
    select max(id) + 1 into skp_id from scheduler_prop;
    insert into scheduler_prop ( id, scheduler, name, value )
    values ( skp_id, sk_id, skp_name, skp_value );
  else
    select t.id into skp_id from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
    update scheduler_prop set value = skp_value where id = skp_id;
  end if;

  skp_name := 'org.quartz.threadExecutor.class';
  skp_value := 'com.ibm.quartz.WorkManagerThreadExecutor';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 0 ) then
    select max(id) + 1 into skp_id from scheduler_prop;
    insert into scheduler_prop ( id, scheduler, name, value )
    values ( skp_id, sk_id, skp_name, skp_value );
  else
    select t.id into skp_id from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
    update scheduler_prop set value = skp_value where id = skp_id;
  end if;

  skp_name := 'org.quartz.threadExecutor.workManagerName';
  skp_value := 'wm/MyQuartz_WM';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 0 ) then
    select max(id) + 1 into skp_id from scheduler_prop;
    insert into scheduler_prop ( id, scheduler, name, value )
    values ( skp_id, sk_id, skp_name, skp_value );
  else
    select t.id into skp_id from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
    update scheduler_prop set value = skp_value where id = skp_id;
  end if;

  skp_name := 'org.quartz.threadPool.workManagerName';
  skp_value := 'wm/MyQuartz_WM';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 0 ) then
    select max(id) + 1 into skp_id from scheduler_prop;
    insert into scheduler_prop ( id, scheduler, name, value )
    values ( skp_id, sk_id, skp_name, skp_value );
  else
    select t.id into skp_id from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
    update scheduler_prop set value = skp_value where id = skp_id;
  end if;
  
  skp_name := 'org.quartz.threadPool.threadCount';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 1 ) then
    delete from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  end if;
  
  skp_name := 'org.quartz.threadPool.threadPriority';
  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  if ( counter = 1 ) then
    delete from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( skp_name );
  end if;
end;
/
commit;
