declare
  cur_pwd      sys_refcursor;
  pwd_id       number(16);
  
  counter      number(16);
begin
  open cur_pwd for select id from pwdcfg where id = 1;
  loop
    fetch cur_pwd into pwd_id;
    exit when cur_pwd%NOTFOUND;
    
    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_NUM_CR';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_NUM_CR', '0' );
    end if;
    
    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_NUM_CR_RANDOM';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_NUM_CR_RANDOM', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_NUM_CORRECT_ANSWER';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_NUM_CORRECT_ANSWER', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_NUM_ATTEMPTS';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_NUM_ATTEMPTS', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_FORGOT_MODE_IMMEDIATE';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_FORGOT_MODE_IMMEDIATE', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_FORGOT_MODE_EMAIL';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_FORGOT_MODE_EMAIL', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_FORGOT_MODE_SMS';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_FORGOT_MODE_SMS', '0' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_FORGOT_MODE_SMS_PROVIDER';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_FORGOT_MODE_SMS_PROVIDER', '' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_MIN_LENGTH_ANSWER';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_MIN_LENGTH_ANSWER', '' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_ENABLE';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_ENABLE', '' );
    end if;

    select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_FORGOT_MODE_EMAIL_WITH_USER_OVERRIDE';
    if ( counter = 0 ) then
      insert into pwdcfgcnt ( id, pwdcfg, name, value )
      values ( pwdcfgcnt_seq.nextval, pwd_id, 'PWDSERVICE_FORGOT_MODE_EMAIL_WITH_USER_OVERRIDE', '0' );
    end if;

    --select count(1) into counter from pwdcfgcnt t where t.pwdcfg = pwd_id and t.name = 'PWDSERVICE_ENABLE';
    --if ( counter = 1 ) then
    --  delete from pwdcfgcnt where name = 'PWDSERVICE_ENABLE';
    --end if;

  end loop;
  close cur_pwd;
end;
/
commit;
