alter table CFG_ACTIVITY add PRODUCT NUMERIC(1) default 0;

comment on column CFG_ACTIVITY.PRODUCT
  is '1=true; 0=false';

CALL SYSPROC.ADMIN_CMD( 'REORG TABLE CFG_ACTIVITY' );

declare
  counter     numeric(16);
begin
  select count(1) into counter from cfg_activity where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_activity set product = 1
    where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    );
  end if;
end;
/
commit;
