alter table CFG_PROCESS add PRODUCT NUMBER(1) default 0;

comment on column CFG_PROCESS.PRODUCT
  is '1=true; 0=false';

declare
  counter     number(16);
begin
  select count(1) into counter from cfg_process where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_process set product = 1
    where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    );
  end if;
end;
/
commit;
