declare
  conf_id          numeric(16)  := 1;
  conf_name        varchar(256) := 'DEFAULT_PAGING_SIZE';
  conf_value       varchar(256) := '25';

  counter          number(16);
begin
  select count(1) into counter from configuration where id = conf_id;
  if ( counter = 0 ) then
    insert into configuration ( id, name, value )
    values ( conf_id, conf_name, conf_value );
  else
    update configuration set name = conf_name, value = conf_value where id = conf_id;
  end if;
end;
/
commit;
