alter table REPORT add DASHBOARD NUMERIC(1) default 0;
alter table REPORT add REPORT NUMERIC(16);

comment on column REPORT.DASHBOARD
  is '0: REPORT - 1:DASHBOARD';
comment on column REPORT.R_QUERY
  is 'Report Query/Dashboard Query reference';
comment on column REPORT.REPORT
  is 'Dashboard Report reference';

alter table REPORT
  add constraint REPORT_REPORT_FK foreign key (REPORT)
  references REPORT (ID);

drop index REPORT_LNAME_IDX;
create unique index REPORT_LNAME_DASHBOARD_IDX on REPORT (lower(name), dashboard)
;

CALL SYSPROC.ADMIN_CMD( 'REORG TABLE REPORT' );
