declare
  counter          number(16);
  
  --report type
  rt_id            number(16);
  rt_name          varchar2(256) := '';
  rt_desc          varchar2(512) := '';

  --report parent
  rp_id            number(16);
  rp_name          varchar2(256) := '';

  r_id             number(16);
  r_name_old       varchar2(256) := 'Technical transformation status';
  r_name           varchar2(256) := 'Business activity mapping status';
  r_desc           varchar2(512) := '';
  r_code           varchar2(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard      number(1) := 1;

  r_loc_id         number(16);
  r_loc_code       varchar2(256);

  rq_id            number(16);
  rq_name_old      varchar2(256) := 'Technical transformation status DB';
  rq_name          varchar2(256) := 'Business activity mapping status DB';
  rq_desc          varchar2(512) := '';
  rqd              clob;
  
  rv_name1         varchar2(256) := 'AG-Core Application';
  repv_vis_type1   number(2) := 3;

  rv_id            number(16);
  rv_name          varchar2(256);
  rv_ent_id        number(16);
  repv_vis_type    number(2);
  rq_vis_pos       number(16);

  rqf_type_def     varchar2(256) := 'java.lang.String';
  rqf_width_def    number(16) := 300;

  rqf_id           number(16);
  rqf_name_old     varchar2(256);
  rqf_name         varchar2(256);
  rqf_type         varchar2(256);
  rqf_width        number(16);
  rqf_ord_by       number(1);
  rqf_ord_by_clau  varchar2(256);
  rqf_ord_pos      number(16);
  loc_id           number(16);
  loc_code_old     varchar2(256);
  loc_code         varchar2(256);
  i18n_msg         varchar2(256);
  repf_pos_id      number(16);
  repf_pos_id_old  number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar2(256) := null;
  rqf_name1        varchar2(256) := 'PERMISSION_STATUS';
  rqf_type1        varchar2(256) := rqf_type_def;
  rqf_width1       varchar2(256) := rqf_width_def;
  rqf_ord_by1      number(1)     := 0;
  rqf_ord_by_clau1 varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar2(256) := null;
  loc_code1        varchar2(256) := 'permission.status';
  i18n_msg1        varchar2(256) := 'Permission Status';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name2_old    varchar2(256) := null;
  rqf_name2        varchar2(256) := 'PERMISSION_COUNT';
  rqf_type2        varchar2(256) := rqf_type_def;
  rqf_width2       varchar2(256) := rqf_width_def;
  rqf_ord_by2      number(1)     := 0;
  rqf_ord_by_clau2 varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code2_old    varchar2(256) := null;
  loc_code2        varchar2(256) := 'permission.count';
  i18n_msg2        varchar2(256) := 'Permission Count';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id2     number(16)    := null;

  repfr_id         number(16);
  repfr_name_old   varchar2(256);
  repfr_name       varchar2(256);
  repfr_value      varchar2(256);
  repfr_l_id       number(16);
  repfr_l_code_old varchar2(256);
  repfr_l_code     varchar2(256);
  repfr_i18n_msg   varchar2(256);
  repfr_vis        number(16);
  repfr_mand       number(16);
  repfr_type       number(16);
  repfr_cust_id    number(16);
  repfr_cust_name  varchar2(256);
  repfr_pos_id     number(16);
  repfr_pos_id_old number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name1_old  varchar2(256);
  repfr_name1      varchar2(256) := 'permission_name';
  repfr_value1     varchar2(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code1_old varchar2(256) := null;
  repfr_l_code1    varchar2(256) := 'permission.name';
  repfr_i18n_msg1  varchar2(256) := 'Permission';
  repfr_vis1       number(16)    := 1;
  repfr_mand1      number(16)    := 0;
  repfr_type1      number(16)    := 0;
  repfr_cust_name1 varchar2(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id1    number(16);
  repfr_pos_id1_old number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name2_old  varchar2(256);
  repfr_name2      varchar2(256) := 'permission_status';
  repfr_value2     varchar2(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code2_old varchar2(256) := null;
  repfr_l_code2    varchar2(256) := 'permission.status';
  repfr_i18n_msg2  varchar2(256) := 'Permission Status';
  repfr_vis2       number(16)    := 1;
  repfr_mand2      number(16)    := 0;
  repfr_type2      number(16)    := 3;
  repfr_cust_name2 varchar2(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id2    number(16);
  repfr_pos_id2_old number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name3_old  varchar2(256);
  repfr_name3      varchar2(256) := 'application_name';
  repfr_value3     varchar2(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code3_old varchar2(256) := null;
  repfr_l_code3    varchar2(256) := 'application.name';
  repfr_i18n_msg3  varchar2(256) := 'Application';
  repfr_vis3       number(16)    := 1;
  repfr_mand3      number(16)    := 0;
  repfr_type3      number(16)    := 0;
  repfr_cust_name3 varchar2(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id3    number(16);
  repfr_pos_id3_old number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name4_old  varchar2(256);
  repfr_name4      varchar2(256) := 'activity_code';
  repfr_value4     varchar2(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code4_old varchar2(256) := null;
  repfr_l_code4    varchar2(256) := 'activity.code';
  repfr_i18n_msg4  varchar2(256) := 'Activity Code';
  repfr_vis4       number(16)    := 1;
  repfr_mand4      number(16)    := 0;
  repfr_type4      number(16)    := 0;
  repfr_cust_name4 varchar2(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id4    number(16);
  repfr_pos_id4_old number(16);

  cur_lan          sys_refcursor;
  lan_id           number(16);
  
  cur_rep          sys_refcursor;
  rep_id           number(16);

begin
  rqd := 'select
'||'  t.permission_status,
'||'  count(1) as permission_count
'||'from
'||'(
'||'  select
'||'  --t.permission_id,
'||'   case
'||'     when t.permission_status = 0 then ''TBD''
'||'     when t.permission_status = 1 then ''Linked''
'||'     when t.permission_status = 0 then ''Ignored''
'||'     when t.permission_status = 3 then ''Missing Activities''
'||'     else ''-''
'||'   end as permission_status,
'||'  --t.permission as ''permission_name'',
'||'  --t.permission_description as permission_desc,
'||'  t.application_name as application_name,
'||'  --t.permission_type_name as profile_type,
'||'  --tp.activity as activity_name,
'||'  --tp.activity_path as activity_path,
'||'  tp.activity_code as activity_code--,
'||'  --tp.env_id,
'||'  --t.permission_code
'||'    from (select e.id     as permission_id,
'||'          e.state         as permission_status,
'||'          --e.name        as permission,
'||'          --e.code        as permission_code,
'||'          --e.description as permission_description,
'||'          a.name        as application_name--,
'||'          --pt.name       as permission_type_name
'||'            from #pmschema#.entitlement  e,
'||'                 #schema_tmp#.tmp_rep_application tmpa,
'||'                 #pmschema#.application  a,
'||'                 #pmschema#.profile_type pt
'||'           where e.ext_type = a.sod_ext_level
'||'             and e.application = tmpa.id
'||'             and tmpa.id = a.id
'||'             and e.profile_type = pt.id
'||'             and e.administrative = 0
'||'             and pt.application = a.id
'||'             and lower ( e.name ) like lower ( ''#permission_name#'' )
'||'             and e.state in (0, 1, 2, 3)) t
'||'    left outer join (select distinct tp.profile,
'||'                                     tp.task,
'||'                                     --t.name as activity,
'||'                                     --t.path as activity_path,
'||'                                     t.code as activity_code,
'||'                                     env.id as env_id
'||'                       from (select pgr.profile, t.task, t.environment
'||'                               from #pmschema#.profile_group pgr,
'||'                                    (select tp.task, pg.root, tp.environment
'||'                                       from #pmschema#.task_profile  tp,
'||'                                            #pmschema#.entitlement   e,
'||'                                            #pmschema#.profile_group pg
'||'                                      where e.int_type = 0
'||'                                        and tp.profile = e.id
'||'                                        and e.administrative = 0
'||'                                        and e.id = pg.profile) t
'||'                              where pgr.root = t.root
'||'                                and pgr.type = 3
'||'                             union
'||'                             select tp.profile, tp.task, tp.environment
'||'                               from #pmschema#.task_profile tp,
'||'                                    #pmschema#.entitlement  e,
'||'                                    #pmschema#.application  a
'||'                              where e.application = a.id
'||'                                and e.ext_type = a.sod_ext_level
'||'                                and e.administrative = 0
'||'                                and tp.profile = e.id) tp,
'||'                            #pmschema#.environment env,
'||'                            #pmschema#.task t
'||'                      where env.working = 1
'||'                        and env.id = tp.environment
'||'                        and tp.environment = t.environment
'||'                        and tp.task = t.id) tp on tp.profile = t.permission_id
'||'   where 1 = 1
'||'     and t.permission_status = #permission_status#
'||'     and lower ( t.application_name ) like lower ( ''#application_name#'' )
'||'     and ( lower ( tp.activity_code ) like lower ( ''#activity_code#'' ) or tp.activity_code is null )
'||') t
'||'group by t.permission_status
'||'';

  --sezione query
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
    if ( counter = 0 ) then
      update r_query set name = rq_name where name = rq_name_old;
    end if;

    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old );
    if ( counter = 1 ) then
      delete r_query where name = rq_name_old;
    end if;
  end if;
  
  --sezione report
  select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      select dbms_random.random into r_loc_code from dual;
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      /*DB2*select int((rand()-0.5) * 32768) into r_loc_code from dual;*DB2*/
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;

    open cur_lan for select t.id from language t where t.language_status > 0;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      
      select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
      if ( counter = 0 ) then
        insert into i18n_message ( id, localization, language, message )
        values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_name );
      else
        update i18n_message set message = r_name where language = lan_id and localization = r_loc_id;
      end if;

    end loop;
    close cur_lan;

    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'CHART', '0' );
    end if;    
  else
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;
  end if;

  --modifica il nome del report
  if ( r_name <> r_name_old ) then
    update report set name = r_name where name = r_name_old and dashboard = r_dashboard;
  end if;
  
  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

  --QUERY FIELD 2: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name2_old;
  rqf_name        := rqf_name2;
  rqf_type        := rqf_type2;
  rqf_width       := rqf_width2;
  rqf_ord_by      := rqf_ord_by2;
  rqf_ord_by_clau := rqf_ord_by_clau2;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code2_old;
  loc_code        := loc_code2;
  i18n_msg        := i18n_msg2;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id2;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 2: END

  --REPORT FILTER 1: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name1_old;
  repfr_name         := repfr_name1;
  repfr_value        := repfr_value1;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code1_old;
  repfr_l_code       := repfr_l_code1;
  repfr_i18n_msg     := repfr_i18n_msg1;
  repfr_vis          := repfr_vis1;
  repfr_mand         := repfr_mand1;
  repfr_type         := repfr_type1;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name1;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id1;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 1 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 1 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(1) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 1 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 1;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 1 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -1 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 1 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -1;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 1: END

  --REPORT FILTER 2: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name2_old;
  repfr_name         := repfr_name2;
  repfr_value        := repfr_value2;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code2_old;
  repfr_l_code       := repfr_l_code2;
  repfr_i18n_msg     := repfr_i18n_msg2;
  repfr_vis          := repfr_vis2;
  repfr_mand         := repfr_mand2;
  repfr_type         := repfr_type2;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name2;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id2;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(2) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(2) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 2 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(2) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(2) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 2 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(2) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 2 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 2;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 2 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 2 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -2 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 2 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 2 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -2;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 2: END

  --REPORT FILTER 3: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name3_old;
  repfr_name         := repfr_name3;
  repfr_value        := repfr_value3;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code3_old;
  repfr_l_code       := repfr_l_code3;
  repfr_i18n_msg     := repfr_i18n_msg3;
  repfr_vis          := repfr_vis3;
  repfr_mand         := repfr_mand3;
  repfr_type         := repfr_type3;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name3;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id3;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(3) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(3) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 3 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(3) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(3) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 3 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(3) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 3 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 3;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 3 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 3 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -3 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 3 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 3 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -3;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 3: END

  --REPORT FILTER 4: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name4_old;
  repfr_name         := repfr_name4;
  repfr_value        := repfr_value4;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code4_old;
  repfr_l_code       := repfr_l_code4;
  repfr_i18n_msg     := repfr_i18n_msg4;
  repfr_vis          := repfr_vis4;
  repfr_mand         := repfr_mand4;
  repfr_type         := repfr_type4;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name4;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id4;
    
  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(4) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(4) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 4 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(4) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(4) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 4 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(4) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 4 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 4;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 4 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 4 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -4 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 4 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 4 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -4;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 4: END

  --QUERY VISIBILITY AND REPORT VISIBILITY 1: BEGIN
  rv_name := rv_name1;
  repv_vis_type := repv_vis_type1;
  select count (1) into counter from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
  if ( counter = 1 ) then
    select rv.id, rv.entity into rv_id, rv_ent_id from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
    
    --QUERY VISIBILITY
    select count(1) into counter from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;

    if ( counter = 0 ) then
      select max ( rqv.position ) + 1 into rq_vis_pos from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;
      if ( rq_vis_pos is null ) then
        rq_vis_pos := 0;
      end if;
      insert into r_query_visibility ( id, r_query, r_visibility, position )
      values ( r_query_visibility_seq.nextval, rq_id, rv_id, rq_vis_pos );
    end if;

    --REPORT VISIBILITY
    select count(1) into counter from report_visibility rv where rv.report = r_id and rv.r_visibility = rv_id;

    if ( counter = 0 ) then
      insert into report_visibility ( id, report, entity, vis_type, r_visibility )
      values ( report_visibility_seq.nextval, r_id, rv_ent_id, repv_vis_type, rv_id );
    end if;
  end if;
  --QUERY VISIBILITY AND REPORT VISIBILITY 1: END

end;
/

commit;
