declare
  r_name           varchar(256) := 'Accounts expiring in next 30 days with OU scope';
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;

  loc_mess_old     varchar(1024) := 'Accounts expiring in next x days UM';
  loc_mess_new     varchar(1024) := 'Accounts expiring in next x days with OU scope';
  
  counter          numeric(16);
begin
  select count(1) into counter from i18n_message t, report r
  where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard;
  if ( counter > 0 ) then
    update i18n_message set message = loc_mess_new where id in (
      select t.id from i18n_message t, report r
      where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard );
  end if;
end;
/
commit;

declare
  r_name           varchar(256) := 'Accounts expiring in next x days with application scope';
  --se 0  un report, se 1  un dashboard
  r_dashboard      numeric(1) := 1;

  loc_mess_old     varchar(1024) := 'Accounts expiring in next x days AM';
  loc_mess_new     varchar(1024) := 'Accounts expiring in next 30 days with application scope';
  
  counter          numeric(16);
begin
  select count(1) into counter from i18n_message t, report r
  where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard;
  if ( counter > 0 ) then
    update i18n_message set message = loc_mess_new where id in (
      select t.id from i18n_message t, report r
      where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard );
  end if;
end;
/
commit;
