declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Access certification campaign pending items DB';

  counter          numeric(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    delete from r_query where id = rq_id;
  end if;
end;
/
commit;

declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Pending requests DB';

  counter          numeric(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    delete from r_query where id = rq_id;
  end if;
end;
/
commit;

declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Requests with escalation DB';

  counter          numeric(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    delete from r_query where id = rq_id;
  end if;
end;
/
commit;

