declare
  r_name           varchar2(256) := 'Illegal user without mitigation';
  --se 0  un report, se 1  un dashboard
  r_dashboard      number(1) := 1;

  loc_mess_old     varchar2(1024) := 'Illegal user without mitigation';
  loc_mess_new     varchar2(1024) := 'User violation without mitigation';
  
  counter          number(16);
begin
  select count(1) into counter from i18n_message t, report r
  where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard;
  if ( counter > 0 ) then
    update i18n_message set message = loc_mess_new where id in (
      select t.id from i18n_message t, report r
      where t.localization = r.localization and t.message = loc_mess_old and r.name = r_name and r.dashboard = r_dashboard );
  end if;
end;
/
commit;
