@echo off
rem DB2 CLIENT CONFIGURATION
set DB2_HOME="c:\Program Files\IBM\SQLLIB"

rem DB2 SERVER CONFIGURATION
set DB2_SERVER=[DB2_FULLY_QUALIFIED_SERVER_NAME]


rem FIXED CONFIGURATION
set UPGRADE_SCRIPT=%cd%

cd %UPGRADE_SCRIPT%\AccessGovernanceCoreBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @agc_pre_req_upgrade_73_to_74.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @agc_pre_req_upgrade_73_to_74.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @arc4s_pre_req_upgrade_73_to_74.sql

cd %UPGRADE_SCRIPT%\Localization
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @agc_localization.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @agc_localization.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @arc4s_localization.sql

cd %UPGRADE_SCRIPT%\AccessGovernanceCoreBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @agc_upgrade_73_to_74.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @agc_upgrade_73_to_74.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @arc4s_upgrade_73_to_74.sql

cd %UPGRADE_SCRIPT%\AccessRequestsBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @arm_upgrade_13_to_14.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @arm_upgrade_13_to_14.sql

cd %UPGRADE_SCRIPT%\AccessOptimizerBackend
call %DB2_HOME%\bin\clpplus -nw aaadm/ideas@%DB2_SERVER% @aa_upgrade_53_to_54.sql
call %DB2_HOME%\bin\clpplus -nw aacore/ideas@%DB2_SERVER% @aa_upgrade_53_to_54.sql

cd %UPGRADE_SCRIPT%\AccessRiskControlsForSAPBackend
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @arc4s_upgrade_43_to_44.sql

cd %UPGRADE_SCRIPT%\DeskBackend
call %DB2_HOME%\bin\clpplus -nw igaserv/ideas@%DB2_SERVER% @desk_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\EmailBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @es_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @es_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\EnterpriseConnectorsBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @ec_upgrade_33_to_34.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @ec_upgrade_33_to_34.sql

cd %UPGRADE_SCRIPT%\JobBackend
call %DB2_HOME%\bin\clpplus -nw aaadm/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw aacore/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw repadm/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw repcore/ideas@%DB2_SERVER% @job_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\ReportBackend
call %DB2_HOME%\bin\clpplus -nw repadm/ideas@%DB2_SERVER% @rd_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw repcore/ideas@%DB2_SERVER% @rd_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\RuleEngineBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @re_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @re_upgrade_23_to_24.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @re_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\TaskPlannerBackend
call %DB2_HOME%\bin\clpplus -nw igaqrz/ideas@%DB2_SERVER% @quartz_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw igaserv/ideas@%DB2_SERVER% @sk_upgrade_23_to_24.sql

cd %UPGRADE_SCRIPT%\AuditHelper
call %DB2_HOME%\bin\clpplus -nw igaserv/ideas@%DB2_SERVER% @account_upgrade_33_to_34.sql

cd %UPGRADE_SCRIPT%\SIB_IB_ILC
call %DB2_HOME%\bin\clpplus -nw itimuser/ideas@%DB2_SERVER% @IB_ILC_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw itiml000/ideas@%DB2_SERVER% @SIB_upgrade.sql

cd %UPGRADE_SCRIPT%\AccessGovernanceCoreBackend
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @report_assignment.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @report_assignment.sql

cd %UPGRADE_SCRIPT%\ReportBackend
call %DB2_HOME%\bin\clpplus -nw repadm/ideas@%DB2_SERVER% @revoke_from_agc.sql
call %DB2_HOME%\bin\clpplus -nw repcore/ideas@%DB2_SERVER% @revoke_from_agc.sql

cd %UPGRADE_SCRIPT%\IdeasModule
call %DB2_HOME%\bin\clpplus -nw aaadm/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw aacore/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw igaadm/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw igacore/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw ccscore/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw repadm/ideas@%DB2_SERVER% @ideas_module_upgrade.sql
call %DB2_HOME%\bin\clpplus -nw repcore/ideas@%DB2_SERVER% @ideas_module_upgrade.sql

cd %UPGRADE_SCRIPT%
