#DB2 CLIENT CONFIGURATION
export DB2_HOME=/home/db2inst1/sqllib

#DB2 SERVER CONFIGURATION
export DB2_SERVER=[DB2_FULLY_QUALIFIED_SERVER_NAME]


#FIXED CONFIGURATION
export UPGRADE_SCRIPT=$PWD

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @agc_pre_req_upgrade_73_to_74.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @agc_pre_req_upgrade_73_to_74.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @arc4s_pre_req_upgrade_73_to_74.sql

cd $UPGRADE_SCRIPT/Localization
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @agc_localization.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @agc_localization.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @arc4s_localization.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @agc_upgrade_73_to_74.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @agc_upgrade_73_to_74.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @arc4s_upgrade_73_to_74.sql

cd $UPGRADE_SCRIPT/AccessRequestsBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @arm_upgrade_13_to_14.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @arm_upgrade_13_to_14.sql

cd $UPGRADE_SCRIPT/AccessOptimizerBackend
$DB2_HOME/bin/clpplus -nw aaadm/ideas@$DB2_SERVER @aa_upgrade_53_to_54.sql
$DB2_HOME/bin/clpplus -nw aacore/ideas@$DB2_SERVER @aa_upgrade_53_to_54.sql

cd $UPGRADE_SCRIPT/AccessRiskControlsForSAPBackend
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @arc4s_upgrade_43_to_44.sql

cd $UPGRADE_SCRIPT/DeskBackend
$DB2_HOME/bin/clpplus -nw igaserv/ideas@$DB2_SERVER @desk_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/EmailBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @es_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @es_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/EnterpriseConnectorsBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @ec_upgrade_33_to_34.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @ec_upgrade_33_to_34.sql

cd $UPGRADE_SCRIPT/JobBackend
$DB2_HOME/bin/clpplus -nw aaadm/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw aacore/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw repadm/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw repcore/ideas@$DB2_SERVER @job_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/ReportBackend
$DB2_HOME/bin/clpplus -nw repadm/ideas@$DB2_SERVER @rd_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw repcore/ideas@$DB2_SERVER @rd_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/RuleEngineBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @re_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @re_upgrade_23_to_24.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @re_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/TaskPlannerBackend
$DB2_HOME/bin/clpplus -nw igaqrz/ideas@$DB2_SERVER @quartz_upgrade.sql
$DB2_HOME/bin/clpplus -nw igaserv/ideas@$DB2_SERVER @sk_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/AuditHelper
$DB2_HOME/bin/clpplus -nw igaserv/ideas@$DB2_SERVER @account_upgrade_33_to_34.sql

cd $UPGRADE_SCRIPT/SIB_IB_ILC
$DB2_HOME/bin/clpplus -nw itimuser/ideas@$DB2_SERVER @IB_ILC_upgrade.sql
$DB2_HOME/bin/clpplus -nw itiml000/ideas@$DB2_SERVER @SIB_upgrade.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @report_assignment.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @report_assignment.sql

cd $UPGRADE_SCRIPT/ReportBackend
$DB2_HOME/bin/clpplus -nw repadm/ideas@$DB2_SERVER @revoke_from_agc.sql
$DB2_HOME/bin/clpplus -nw repcore/ideas@$DB2_SERVER @revoke_from_agc.sql

cd $UPGRADE_SCRIPT/IdeasModule
$DB2_HOME/bin/clpplus -nw aaadm/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw aacore/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw igaadm/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw igacore/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw ccscore/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw repadm/ideas@$DB2_SERVER @ideas_module_upgrade.sql
$DB2_HOME/bin/clpplus -nw repcore/ideas@$DB2_SERVER @ideas_module_upgrade.sql

cd $UPGRADE_SCRIPT
